package cordova.plugins;

import org.apache.cordova.CordovaWebView;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CordovaInterface;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.stroeven.greeter.*;
import com.viatom.azur.bluetooth.BTUtils;

import android.content.ServiceConnection;
import android.content.Intent;
import android.app.Service;
import android.content.ComponentName;
import android.os.IBinder;
import android.os.Binder;
import android.content.Context;


public class checkMeInterface extends CordovaPlugin{

    private CordovaInterface cordova;
    private CordovaWebView webView;
    private Binder mBinder;

	@Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
    	super.initialize(cordova, webView);
    	this.cordova = cordova;
    	this.webView = webView;
    }

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("sayHello")) {
            callbackContext.success(sayHello());
            return true;
        }
        if(action.equals("initBTUtils")){
            callbackContect.success(bindBTUtils());
        }
        return false;
    }

    public String sayHello(){
        return Greeter.greet();
    }

    public String bindBTUtils(){
        testBindService();
        return "BTUtils bound - ready to proceed";
    }

    public void testBindService(){
          cordova.getActivity().getApplicationContext().bindService(new Intent("com.viatom.azur.BTUtils"), conn, Service.BIND_AUTO_CREATE);
    }

    private ServiceConnection conn = new ServiceConnection(){
            @Override
            public void onServiceConnected(ComponentName name, IBinder service){
                System.out.println("BTUtils service connected");
                mBinder = (BTUtils.BTBinder)service;
            }

            @Override
            public void onServiceDisconnected (ComponentName name){
                System.out.println("Service has been disconnected.");
            }
    };
}